CLS
PRINT "******************************************************************"
PRINT "* DTOA is a sample QuickBASIC program to set the two D/A output  *"
PRINT "* channels in the LPT:Analog_I/0! 12-bit A/D and D/A printer     *"
PRINT "* port adapter.                                                  *"
PRINT "*                                                                *"
PRINT "* (c) Copyright 1996, ADNAV Electronics                          *"
PRINT "*                                                                *"
PRINT "* ADNAV Electronics           (409)292-0988                      *"
PRINT "* 58 Chicory Court, Lake Jackson, TX  77566                      *"
PRINT "******************************************************************"
PRINT
'
' Printer port locations
' ----------------------
CONST prinop = &H378   ' Printer Output Port (could be &H278 or &H3BC)
CONST princon = &H37A  ' Printer Control Port (could be &H27A or &H3BE)
CONST prinstat = &H379 ' Printer Status Port (could be &H279 or &H3BD)
'
' Define control pin locations
' ----------------------------
CONST notdaclk = 1, notdacs = 2, dadat = 4
'
DIM dtoa1, dtoa2, clocknum AS INTEGER
main:
PRINT
INPUT "Please input data for D/A channel 1 (between 0 and 4095 mV) "; dtoa1
INPUT "Please input data for D/A channel 2 (between 0 and 4095 mV) "; dtoa2
GOSUB dtoa       'convert data to analog
BEEP
PRINT
PRINT "Output of D/A channel 1 is now = "; dtoa1; " mV"
PRINT "output of D/A channel 2 is now = "; dtoa2; " mV"
PRINT
INPUT "Would you like to enter a different set (y/n) "; dummy$
IF (dummy$ = "y" OR dummy$ = "Y") THEN GOTO main ELSE END
END


dtoa:
'
' D/A Output Routine
' ------------------
'
' dtoa1 contains the code for the desired D/A channel 1 output
' dtoa2 contains the code for the desired D/A channel 2 output
'
OUT princon, notdaclk                      ' set D/A clock line low
OUT princon, notdaclk + notdacs            ' assert D/A CS' line
FOR clocknum = 11 TO 0 STEP -1             ' clock 12 bits of D/A channel 1
                                           ' from MSB to LSB
   IF (dtoa1 AND (2 ^ clocknum)) = 0 THEN  ' if current bit converts to 0
      OUT princon, notdacs                 ' then do not set data bit high
                                           ' while causing a clock rising edge
      FOR delay = 1 TO 5: NEXT delay
      OUT princon, notdacs + notdaclk      ' return clock line to low
   ELSE                                    ' if, on the other hand, current
                                           ' bit converts to one
      OUT princon, notdacs + notdaclk + dadat  ' then set data bit high while
                                               ' maintaining the 'CS and clock
                                               ' lines low
      FOR delay = 1 TO 5: NEXT delay
      OUT princon, notdacs + dadat             ' cause clock rising edge to
                                               ' clock data bit in
      FOR delay = 1 TO 5: NEXT delay
      OUT princon, notdacs + notdaclk + dadat  ' return clock line to low
   END IF
NEXT clocknum                               ' next bit
FOR delay = 1 TO 5: NEXT delay
FOR clocknum = 11 TO 0 STEP -1              ' clock 12 bits of D/A channel 2
                                            ' in the same way
   IF (dtoa2 AND (2 ^ clocknum)) = 0 THEN
      OUT princon, notdacs
      FOR delay = 1 TO 5: NEXT delay
      OUT princon, notdacs + notdaclk
   ELSE
      OUT princon, notdacs + notdaclk + dadat
      FOR delay = 1 TO 5: NEXT delay
      OUT princon, notdacs + dadat
      FOR delay = 1 TO 5: NEXT delay
      OUT princon, notdacs + notdaclk + dadat
   END IF
FOR delay = 1 TO 5: NEXT delay
NEXT clocknum
OUT princon, 0                              ' update D/A data by deasserting 'CS
                                            ' under this condition, clock and
                                            ' data states are of no relevance
RETURN

