Attribute VB_Name = "Module1"
' This module contains the general declarations required
' to operate the LPT:Analog! model 8c-I/O
'
' (c) 1997 ADNAV Electronics
'
' ADNAV Electronics
' 58 Chicory Ct.
' Lake Jackson, TX 77566
' U.S.A.
'
' Declare DLL to enable I/O through the printer port
' --------------------------------------------------
'
Public Declare Function Inp Lib "inpout32.dll" _
Alias "Inp32" (ByVal PortAddress As Integer) As Byte
Public Declare Sub Out Lib "inpout32.dll" _
Alias "Out32" (ByVal PortAddress As Integer, ByVal Value As Byte)
'
' Printer port locations
' ----------------------
Global Const prinop1 = &H378     ' Printer Output Port for LPT1
Global Const prinstat1 = &H379   ' Printer Status Port for LPT1
Global Const princont1 = &H37A   ' Printer Control Port for LPT1
Global Const prinop2 = &H278     ' Printer Output Port for LPT2
Global Const prinstat2 = &H279   ' Printer Status Port for LPT2
Global Const princont2 = &H27A   ' Printer Control Port for LPT2
Global Const prinop3 = &H3BC     ' Printer Output Port for LPT3
Global Const prinstat3 = &H3BD   ' Printer Status Port for LPT3
Global Const princont3 = &H3BE   ' Printer Control Port for LPT3
'
' Define control pin locations for LPT:Analog! model 8c-I/O
' ---------------------------------------------------------
Global Const notdaclk = 1, notdacs = 2, dadat = 4
' notdaclk is the D/A serial clock line (active low)
' notdacs  is the D/A chip select line  (active low)
' dadat    is the D/A serial data input line
Global Const power = 12, notcs = 1, sclk = 2, muxd0 = 16, muxd1 = 32, muxd2 = 64
' power    are the two D/A power supply lines
' notcs    is the A/D chip select line (active low)
' sclk     is the A/D serial clock line
' muxd0    is the A/D input multiplexer data line 0
' muxd1    is the A/D input multiplexer data line 1
' muxd2    is the A/D input multiplexer data line 2
'
' Define variables for printer port location
' ------------------------------------------
Global prinop        ' Printer Port Output Port location variable
Global prinstat      ' Printer Port Status Port location variable
Global princont      ' Printer Port Control Port location variable

