Attribute VB_Name = "Module4"
Function dtoa(dtoa1 As Integer, dtoa2 As Integer) As Integer
'
' Function DtoA(dtoa1,dtoa2) executes the serial protocol to update D/A
' converters with the values defined by dtoa1 and dtoa2, where
' dtoa1 contains the code for the desired D/A channel 1 output
' dtoa2 contains the code for the desired D/A channel 2 output
'
' (c) 1997 ADNAV Electronics
'
' ADNAV Electronics
' 58 Chicory Ct.
' Lake Jackson, TX 77566
' U.S.A.
'
' Define variables
' ----------------
Dim bit3 As Integer                 ' value of Control *D3
Dim clocknum As Integer             ' clock pulse counter
Dim delay As Integer                ' delay loop dummy variabe
' D/A loop
' --------
bit3 = Inp(princont) And 8          ' evaluate current status of Control *D3
Out princont, notdaclk + bit3              ' set D/A clock line low without
                                           ' upsetting bit3 of the Control port
Out princont, notdaclk + notdacs + bit3    ' assert D/A CS' line without
                                           ' upsettin bit 3 of the Control port
For clocknum = 11 To 0 Step -1             ' clock 12 bits of D/A channel 1
                                           ' from MSB to LSB
   If (dtoa1 And (2 ^ clocknum)) = 0 Then  ' if current bit converts to 0
      Out princont, notdacs + bit3         ' then do not set data bit high
                                           ' while causing a clock rising edge
                                           ' all without upsetting bit 3 of the Control port
      For delay = 1 To 5: Next delay
      Out princont, notdacs + notdaclk + bit3  ' return clock line to low
                                               ' without upsetting bit 3 of the Control port
   Else                                    ' if, on the other hand, current
                                           ' bit converts to one
      Out princont, notdacs + notdaclk + dadat + bit3 ' then set data bit high while
                                               ' maintaining the 'CS and clock and do not
                                               ' upset bit 3 of the Control port
                                               ' lines low
      For delay = 1 To 5: Next delay           ' introduce delay to comply with IC's
                                               ' timing requirements
      Out princont, notdacs + dadat + bit3     ' cause clock rising edge to
                                               ' clock data bit in without upsetting
                                               ' bit 3 of the Control port
      For delay = 1 To 5: Next delay           ' introduce delay to comply with IC's
                                               ' timing requirements
      Out princont, notdacs + notdaclk + dadat + bit3 ' return clock line to low without
                                                      ' upsetting bit 3 of the Control port
   End If
Next clocknum                               ' next bit
For delay = 1 To 5: Next delay
For clocknum = 11 To 0 Step -1              ' clock 12 bits of D/A channel 2
                                            ' in the same way
   If (dtoa2 And (2 ^ clocknum)) = 0 Then
      Out princont, notdacs + bit3
      For delay = 1 To 5: Next delay
      Out princont, notdacs + notdaclk + bit3
   Else
      Out princont, notdacs + notdaclk + dadat + bit3
      For delay = 1 To 5: Next delay
      Out princont, notdacs + dadat + bit3
      For delay = 1 To 5: Next delay
      Out princont, notdacs + notdaclk + dadat + bit3
   End If
For delay = 1 To 5: Next delay
Next clocknum
Out princont, bit3             ' update D/A data by deasserting 'CS
                               ' without upsetting bit 3 of the Control port
                               ' under this condition, clock and
                               ' data states are of no relevance

dtoa = 0                       ' dummy return variable = 0
End Function
