function v=mat2arb(x,filename);
%MAT2ARB saves 2 vectors as a file that can be loaded into the 
%2-channel Arbitrary Waveform Generator
%        x = input matrix [vector 1 ; vector 2] sample value range = 0 to 4095
%        filename = filename where arb file is to be saved entered as 'filename.ext'
%
%(c) 2003 David Prutchi and Michael Norris
%
if min(min(x))<0;
    disp('minimum sample value found')
    disp(min(min(x)))
    error('sample value range must be between 0 and 4095')
end
if max(max(x))>4095;
    disp('maximum sample value found')
    disp(max(max(x)))
    error('sample value range must be between 0 and 4095')
end
n = length(x);                               % n is the length of the vectors
zer=zeros(1,n);                              % generate vector of zeros for marker channels
y = 1:n;                                     % generate vector of sample indexes
v=[x(1,y);x(2,y);zer(y);zer(y)];             % marker channels always low
fid = fopen(filename,'w');                   % open file for output
fprintf(fid,'%1g , %1g , %1g , %1g \r',v);   % write file in format suitable for ARB
fclose(fid)                                  % close file
