function rate = alpha_m(V_membrane)
%
% Rate constant alpha_m
%
% This rate constant has a singularity at V_membrane=25 which must
% be treated separately by applying L'Hopitals Rule
%
rate = zeros(size(V_membrane));
%
% Non-Singular Case
% -----------------
idx = find(V_membrane~=25.0);
if(~isempty(idx))
  rate(idx) = 0.1*(-V_membrane(idx)+25.0) ./ (exp((-V_membrane(idx)+25.0)/10.0)-1.0);
end
%
% Handle Singularity at V_membrane=25
% -----------------------------------
idx = find(V_membrane == 25.0);
if(~isempty(idx))
  rate(idx) = 1.0/exp((-V_membrane(idx)+25.0)/10.0);
end

